#*************************************************************
# Progamm:			gitter_1d
# Sinn des Programms: 		Gittergenerator 1d
# Sinn der Einheit  :		Ausgabe des Gitters
# Name dieser Datei:		ausgabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		gitter_1d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	4
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			12.04.2018
# Letzte Änderung: 		08.02.2024
#*************************************************************



#*************************************************************
# Importieren der Klassen
# matplotlib.pyplot: für graphische Ausgabe
#*************************************************************

import os
import pickle
import matplotlib.pyplot as plt
#import numpy as np

#*************************************************************
# Klassendefinition: Ausgabe
#*************************************************************



class Ausgabe:
  #Konstruktormethode
  def __init__(self):		
    print("Ausgabeobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Ausgabeobjekt entfernt") 

  def ausgabe_rückgabeliste_init(self):
    self.rückgabeliste = list(range(10))
    print("init: rückgabeliste")

  def schirm_ausgabe_fdm(self,m, x, delta_x):
    try:
      print("FDM-Schirmausgabe")
      for i in range(m):
        print(i, x[i])
      for i in range(m-1):
        print(i, delta_x[i])
      self.rückgabeliste[0] = True        
      self.rückgabeliste[1] = "FDM-Gitter auf Schirm ausgegeben." 
    except:
      self.rückgabeliste[0] = False    
      self.rückgabeliste[1] = "Fehler bei FDM-Gitter Schirmausgegabe."                
    return self.rückgabeliste[0]          

  def schirm_ausgabe_fvm(self, m, x, delta_x, x_gf,  A_gf,Delta_x, V, n_vektor_west, n_vektor_ost):
    try:
      print("FVM-Schirmausgabe")
      for i in range(m):
        print(i, x[i])
      for i in range(m-1):
        print(i, x_gf[i])
      for i in range(m-1):
        print(i, delta_x[i])
      for i in range(m-1):
        print(i, A_gf[i])
      for i in range(0,m-2):
        print(i, Delta_x[i])
      print("Oberheiden")  
      for i in range(0,m-2):
        print("V[",i,"]", V[i], "n_vektor_west[",i,"]", n_vektor_west[i], "n_vektor_ost[",i,"]", n_vektor_ost[i])    
      self.rückgabeliste[0] = True        
      self.rückgabeliste[1] = "FVM-Gitter auf Schirm ausgegeben." 
    except:
      self.rückgabeliste[0] = False    
      self.rückgabeliste[1] = "Fehler bei FVM-Gitter Schirmausgegabe."                
    return self.rückgabeliste[0]
    
    
  def datei_ausgabe_fdm(self,gitter_datei,index_ausgabe_wähler, ascii_bin, m, x, delta_x):
    try:
      if ascii_bin == "a":
        with open(gitter_datei, "w") as fobj_out: 
          fobj_out.write(str(index_ausgabe_wähler))
          fobj_out.write("\n")
          fobj_out.write("d")
          fobj_out.write("\n")
          fobj_out.write(str(m))
          fobj_out.write("\n")
          if index_ausgabe_wähler:
            self.rückgabeliste[5] = "Indexausgabe  in Datei" 
            for i in range(m):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(x[i]))
              fobj_out.write("\n")
            for i in range(m-1):
              fobj_out.write(str(i))
              fobj_out.write("\t")
              fobj_out.write(str(delta_x[i]))
              fobj_out.write("\n")
          else:
            self.rückgabeliste[5] = "keine Indexausgabe in Datei"         
            for i in range(m):
              fobj_out.write(str(x[i]))
              fobj_out.write("\n")
            for i in range(m-1):
              fobj_out.write(str(delta_x[i]))
              fobj_out.write("\n") 
          self.rückgabeliste[4] = "Dateiausgabe in ASCII-Code"                  

      elif ascii_bin == "b":
        with open(gitter_datei, "wb") as fobj_out: 
          print("Binär o.k.")
          pickle.dump("d",fobj_out)
          pickle.dump(m,fobj_out)
          pickle.dump(x,fobj_out)
          pickle.dump(delta_x,fobj_out)   
          self.rückgabeliste[4] = "Dateiausgabe binär" 
          self.rückgabeliste[5] = "keine Indexausgabe in Datei"         

      else:
        print("Fehler!") 
        self.rückgabeliste[4] = "Fehler in Zuordnung ASCII- oder Binärcodeausgabe"
      self.rückgabeliste[2] = True        
      self.rückgabeliste[3] = "FDM-Gitter in Datei "+ gitter_datei + " ausgegeben."   
    except:     
      self.rückgabeliste[2] = False    
      self.rückgabeliste[3] = "Fehler bei FDM-Gitter Dateiausgegabe."                
    return self.rückgabeliste[2]
                                          
  def datei_ausgabe_fvm(self,gitter_datei, index_ausgabe_wähler, ascii_bin, m,x, delta_x, x_gf, A_gf, Delta_x, V, n_vektor_west, n_vektor_ost):
    try:
      if ascii_bin == "a":   
        self.rückgabeliste[4] = "Ausgabe in ASCII-Code"       
        fobj_out = open(gitter_datei,"w")
        fobj_out.write(str(index_ausgabe_wähler))
        fobj_out.write("\n")
        fobj_out.write("v")
        fobj_out.write("\n")
        fobj_out.write(str(m))
        fobj_out.write("\n")
        if index_ausgabe_wähler:
          self.rückgabeliste[5] = "Indexausgabe in Datei"        
          for i in range(0,m):
            fobj_out.write(str(i))
            fobj_out.write("\t")
            fobj_out.write(str(x[i]))
            fobj_out.write("\n")
          for i in range(0,m-1):
            fobj_out.write(str(i))
            fobj_out.write("\t")
            fobj_out.write(str(delta_x[i]))
            fobj_out.write("\n")
          for i in range(0,m-1):
            fobj_out.write(str(i))
            fobj_out.write("\t")
            fobj_out.write(str(x_gf[i]))
            fobj_out.write("\n")
          for i in range(0,m-1):
            fobj_out.write(str(i))
            fobj_out.write("\t")
            fobj_out.write(str(A_gf[i]))
            fobj_out.write("\n")
          for i in range(0,m-2):
            fobj_out.write(str(i))
            fobj_out.write("\t")
            fobj_out.write(str(Delta_x[i]))
            fobj_out.write("\n")
          for i in range(0,m-2):
            fobj_out.write(str(i))
            fobj_out.write("\t")
            fobj_out.write(str(V[i]))
            fobj_out.write("\t")
            fobj_out.write(str(n_vektor_west[i]))     
            fobj_out.write("\t")
            fobj_out.write(str(n_vektor_ost[i]))                                 
            fobj_out.write("\n")
        else:
          self.rückgabeliste[5] = "Keine Indexausgabe in Datei"        
          for i in range(0,m):
            fobj_out.write(str(x[i]))
            fobj_out.write("\n")
          for i in range(0,m-1):
            fobj_out.write(str(delta_x[i]))
            fobj_out.write("\n")
          for i in range(0,m-1):
            fobj_out.write(str(x_gf[i]))
            fobj_out.write("\n")
          for i in range(0,m-1):
            fobj_out.write(str(A_gf[i]))
            fobj_out.write("\n")
          for i in range(0,m-2):
            fobj_out.write(str(Delta_x[i]))
            fobj_out.write("\n")
          for i in range(0,m-2):
            fobj_out.write(str(V[i]))
            fobj_out.write("\t")
            fobj_out.write(str(n_vektor_west[i]))     
            fobj_out.write("\t")
            fobj_out.write(str(n_vektor_ost[i]))              
            fobj_out.write("\n")    
        self.rückgabeliste[4] = "Dateiausgabe in ASCII-Code"                   
        fobj_out.close() 
      elif ascii_bin == "b":
        fobj_out = open(gitter_datei,"wb")
        pickle.dump("v",fobj_out)
        pickle.dump(m,fobj_out)
        pickle.dump(x,fobj_out)
        pickle.dump(delta_x,fobj_out)
        pickle.dump(x_gf,fobj_out)
        pickle.dump(A_gf,fobj_out)
        pickle.dump(Delta_x,fobj_out)
        pickle.dump(V,fobj_out)    
        pickle.dump(n_vektor_west,fobj_out) 
        pickle.dump(n_vektor_ost,fobj_out)                 
        self.rückgabeliste[4] = "Dateiausgabe binär" 
        self.rückgabeliste[5] = "keine Indexausgabe in Datei"                     
        fobj_out.close() 
      else:  
        print("Fehler!")
        self.rückgabeliste[4] = "Fehler in Zuordnung ASCII- oder Binärcodeausgabe"
      self.rückgabeliste[2] = True        
      self.rückgabeliste[3] = "FVM-Gitter in Datei " + gitter_datei + " ausgegeben."   
    except:     
      self.rückgabeliste[2] = False    
      self.rückgabeliste[3] = "Fehler bei FVM-Gitter Dateiausgegabe."                
    return self.rückgabeliste[2]      


  def graphik_ausgabe_fdm(self, m,x,graphik_datei_ausgabe_wähler ,graphik_datei_name, graphik_datei_format):
    try:
      x_min=0.0
      x_max=0.0
      for i in range(m):
        if x_min >= x[i]:
          x_min = x[i]
        if x_max <= x[i]:
          x_max = x[i]
      k = list(range(m))
      for i in range(m):
        k[i] = 0.0
      plt.plot(x, k, 'r.')  
      # Achsen-Bereiche manuell festlegen
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
      x_min-=(x_max-x_min)/10.0
      x_max+=(x_max-x_min)/10.0
      plt.axis([x_min, x_max, -0.2, 0.2])
      plt.title("FDM-Gitter" )
      # Ein gepunktetes Diagramm-Gitter einblenden:
      plt.grid(True)
      if(graphik_datei_ausgabe_wähler ):
        try:
          plt.savefig(graphik_datei_name + '.' + graphik_datei_format, format=graphik_datei_format) 
          self.rückgabeliste[8] = True
          self.rückgabeliste[9] = "Graphikdateiausgabe in " + graphik_datei_name + "." + graphik_datei_format + " o.k."
        except:
          print("Graphikdateiformat",graphik_datei_format ,"wird nicht von python unterstützt") 
          print(" unterstützt werden die Formate:",{'eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'} )        
          self.rückgabeliste[8] = False
          self.rückgabeliste[9] = "Fehler in der Graphikdateiausgabe!"  
      plt.show()
      self.rückgabeliste[6] = True 
      self.rückgabeliste[7] = "Graphikausgabe o.k."            
    except:    
      self.rückgabeliste[6] = False  
      self.rückgabeliste[7] = "Fehler in der Graphikausgabe." 
    return self.rückgabeliste[6]  

  def graphik_ausgabe_fvm(self,m,x,x_gf,graphik_datei_ausgabe_wähler ,graphik_datei_name,graphik_datei_format):
    try:
      x_min=0.0
      x_max=0.0
      for i in range(m):
        if x_min >= x[i]:
          x_min = x[i]
        if x_max <= x[i]:
          x_max = x[i]
      k = list(range(m))
      l = list(range(m-1))
      for i in range(m):
        k[i] = 0.0
      for i in range(m-1):
        l[i] = 0.0
      plt.plot(x,k, 'r.')  
      plt.plot(x_gf,l, 'b|') 
#    plt.legend(['Legend']) 
#    plt.plot(x,k,  'r.',label=r'Knotenpunkte')
#    plt.plot(x_gf,l,  'b|',label=r'Wandpositionen')   
      # Achsen-Bereiche manuell festlegen
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
      x_min-=(x_max-x_min)/10.0
      x_max+=(x_max-x_min)/10.0
      plt.axis([x_min, x_max, -0.2, 0.2])
      plt.title("FVM-Gitter" )

    
      # Ein gepunktetes Diagramm-Gitter einblenden:
      plt.grid(True)
      if(graphik_datei_ausgabe_wähler ):
        try:
          plt.savefig(graphik_datei_name + '.' + graphik_datei_format, format=graphik_datei_format) 
          self.rückgabeliste[8] = True
          self.rückgabeliste[9] = "Graphikdateiausgabe in " + graphik_datei_name + "." + graphik_datei_format + " o.k."
        except:
          print("Graphikdateiformat",graphik_datei_format ,"wird nicht von python unterstützt") 
          print(" unterstützt werden die Formate:",{'eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'} )        
          self.rückgabeliste[8] = False
          self.rückgabeliste[9] = "Fehler in der Graphikdateiausgabe!" 
      plt.show()
      self.rückgabeliste[6] = True
      self.rückgabeliste[7] = "Graphikausgabe o.k."             
    except:   
      self.rückgabeliste[6] = False   
      self.rückgabeliste[7] = "Fehler in der Graphikausgabe."  
    return self.rückgabeliste[6]    
