#*************************************************************
# Progamm:			fluisa_gitter_1d
# Sinn des Programms: 		Gittergenerator für 1d-Gitter
# Sinn der Einheit  :		Hauptprogramm	
# Name dieser Datei:		fluisa_gitter_1d_haupt.py
# Versionsnummer:		1
# Wird aufgerufen von:		-
# Ruft auf:			steuer.py, gitter.py, ausgabe.py
# Nummer im Programmpaket:	1
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			01.12.2017
# Letzte Änderung: 		08.02.2024
#*************************************************************

#*************************************************************
# Importieren der Klassen zur Zeitdokumentation
#*************************************************************

import time
import datetime

#*************************************************************
# Importieren der Klassen
#*************************************************************

from steuer import Steuer
from gitter import Gitter
from ausgabe import Ausgabe

steuer = Steuer()
gitter = Gitter()
ausgabe = Ausgabe()

print("Modulname =", __name__)

if __name__ == "__main__":
  print("gitter_1d:")

#*************************************************************
# Berechnung der Startzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Startzeit zu einem String "datum_zeit_anfang"
#*************************************************************
  dt_start = datetime.datetime.now()
  lt_start = time.localtime()
  jahr, monat, tag, stunde, minute, sekunde  = lt_start[0:6]
  datum_zeit_anfang = "Start der Rechnung: \nDatum: " +str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)

#*************************************************************
# Einlesen der Steuerdaten und Erfolgskontrolle
#*************************************************************
  if(steuer.steuer_input()):
#*************************************************************
# Aufruf des Gitterrechners
#*************************************************************
    if gitter.gitter_rechner(steuer.gitter_typ,steuer.m,steuer.x_west, steuer.x_ost, steuer.A_init):
      ausgabe.ausgabe_rückgabeliste_init()
      if steuer.schirm_ausgabe_wähler:
        if steuer.gitter_typ == "d":
          ausgabe.schirm_ausgabe_fdm(steuer.m, gitter.x, gitter.delta_x)
        elif steuer.gitter_typ == "v":
          ausgabe.schirm_ausgabe_fvm( steuer.m, gitter.x, gitter.delta_x, gitter.x_gf,  gitter.A_gf,gitter.Delta_x, gitter.V, gitter.n_vektor_west,\
          gitter.n_vektor_ost)
        else:
          print("Fehler in Schirmausgabe.") 

      if steuer.datei_ausgabe_wähler:
        if steuer.gitter_typ == "d":
          ausgabe.datei_ausgabe_fdm(steuer.gitter_datei, steuer.index_ausgabe_wähler,steuer.ascii_bin,steuer.m, gitter.x, gitter.delta_x)
        elif steuer.gitter_typ == "v":
          ausgabe.datei_ausgabe_fvm(steuer.gitter_datei, steuer.index_ausgabe_wähler,steuer.ascii_bin,steuer.m,gitter.x, gitter.delta_x,\
          gitter.x_gf,gitter.A_gf, gitter.Delta_x, gitter.V, gitter.n_vektor_west, gitter.n_vektor_ost) 
        else:
          print("Fehler im System")
              
      if steuer.graphik_ausgabe_wähler:
        if steuer.gitter_typ == "d":
          ausgabe.graphik_ausgabe_fdm(steuer.m, gitter.x,steuer.graphik_datei_ausgabe_wähler ,steuer.graphik_datei_name, steuer.graphik_datei_format) 
        elif steuer.gitter_typ == "v":
          ausgabe.graphik_ausgabe_fvm(steuer.m, gitter.x, gitter.x_gf,steuer.graphik_datei_ausgabe_wähler ,steuer.graphik_datei_name,\
          steuer.graphik_datei_format)          
        else:
          print("Fehler im System")
         
#*************************************************************
# Fehler bei der Gitterberechnung
#*************************************************************
    else:
      print( "Fehler bei der Berechnung des Gitters")

#*************************************************************
# Fehle beim Einlesen der Steuerdatei
#*************************************************************    
  else:
    print(steuer.rückgabeliste[3]) 
#*************************************************************
# Berechnung der Endzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Endzeit zu einem String "datum_zeit_ende"
#*************************************************************
  lt_end = time.localtime()
  jahr, monat, tag, stunde, minute, sekunde  = lt_end[0:6]
  datum_zeit_ende = "Ende der Rechnung: \nDatum: "+str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)
  dt_end = datetime.datetime.now()

#*************************************************************
# Berechnung der Rechendauer mit dem Zeitdifferenzoperator 
# des Moduls datetime
#*************************************************************
  dauer = dt_end - dt_start

#*************************************************************
# Öffnen der log-Datei
#*************************************************************
  with open("fluisa_gitter_1d.log", "w") as fobj_log:
#*************************************************************
# Schreiben von Datum und Zeit des Programmstarts 
# in die Logdatei 
#*************************************************************
    fobj_log.write(datum_zeit_anfang + "\n")

#*************************************************************
# Schreiben von Datum und Zeit des Programmendes und der 
# Rechendauer in die Logdatei 
#*************************************************************
    fobj_log.write(datum_zeit_ende + "\n")
    fobj_log.write("Rechendauer: "+ "\n" + str(dauer) + "\n")

    fobj_log.write(steuer.rückgabeliste[1] + "\n")
    fobj_log.write(steuer.rückgabeliste[3]  + "\n")
    fobj_log.write(steuer.rückgabeliste[5]  + "\n")
    if(steuer.rückgabeliste[4] == True):
      fobj_log.write(steuer.rückgabeliste[7] + "\n")
    else:
      fobj_log.write("Keine manuelle Änderung der Steuerdaten." + "\n")
    fobj_log.write(gitter.rückgabeliste[2] + "\n") 
    fobj_log.write(ausgabe.rückgabeliste[1] + "\n")
    fobj_log.write(ausgabe.rückgabeliste[3] + "\n") 
    fobj_log.write(ausgabe.rückgabeliste[4] + "\n")
    fobj_log.write(ausgabe.rückgabeliste[5] + "\n") 
    fobj_log.write(ausgabe.rückgabeliste[7] + "\n")
    fobj_log.write(ausgabe.rückgabeliste[9] + "\n") 

#*************************************************************
# Importieren der Klasse tkinter für GUI-Elemente
#*************************************************************
  import tkinter
  main = tkinter.Tk()

#*************************************************************
#Funktion zum Auflösen der Benutzeroberfläche
#*************************************************************
  def ende():
    main.destroy()

#*************************************************************
# GUI-Fuktion
#*************************************************************    
  lb_prozeß_ausgabe_zeit_anfang = tkinter.Label(main, text = datum_zeit_anfang)
  lb_prozeß_ausgabe_zeit_anfang.pack()
  lb_prozeß_ausgabe_zeit_ende = tkinter.Label(main, text = datum_zeit_ende)
  lb_prozeß_ausgabe_zeit_ende.pack()
  lb_prozeß_ausgabe_zeit_ende = tkinter.Label(main, text = "Rechenzeit:  " + str(dauer))
  lb_prozeß_ausgabe_zeit_ende.pack() 
  lb_prozeß_ausgabe_steuer_datei_vorhanden = tkinter.Label(main, text = steuer.rückgabeliste[1])
  lb_prozeß_ausgabe_steuer_datei_vorhanden.pack()             
  lb_prozeß_ausgabe_steuer_gelesen = tkinter.Label(main, text = steuer.rückgabeliste[3])
  lb_prozeß_ausgabe_steuer_gelesen.pack()
  lb_prozeß_ausgabe_steuer_änderung_gemacht = tkinter.Label(main, text = steuer.rückgabeliste[5])
  lb_prozeß_ausgabe_steuer_änderung_gemacht.pack()
  lb_prozeß_ausgabe_steuer_änderung_ok = tkinter.Label(main, text = steuer.rückgabeliste[7])
  lb_prozeß_ausgabe_steuer_änderung_ok.pack()
  lb_prozeß_ausgabe_gitter = tkinter.Label(main, text = gitter.rückgabeliste[1])
  lb_prozeß_ausgabe_gitter.pack()
  lb_prozeß_ausgabe_gitter_art = tkinter.Label(main, text = gitter.rückgabeliste[2])
  lb_prozeß_ausgabe_gitter_art.pack()
  lb_prozeß_ausgabe_schirm_ausgabe = tkinter.Label(main, text = ausgabe.rückgabeliste[1])
  lb_prozeß_ausgabe_schirm_ausgabe.pack()
  lb_prozeß_ausgabe_datei_ausgabe = tkinter.Label(main, text = ausgabe.rückgabeliste[3])
  lb_prozeß_ausgabe_datei_ausgabe.pack()
  lb_prozeß_ausgabe_gitter_datei_ascii_bin = tkinter.Label(main, text = ausgabe.rückgabeliste[4])
  lb_prozeß_ausgabe_gitter_datei_ascii_bin.pack()
  lb_prozeß_ausgabe_gitter_datei_indizes = tkinter.Label(main, text = ausgabe.rückgabeliste[5])
  lb_prozeß_ausgabe_gitter_datei_indizes.pack()
  lb_prozeß_ausgabe_gitter_graphik_ausgabe = tkinter.Label(main, text = ausgabe.rückgabeliste[7])
  lb_prozeß_ausgabe_gitter_graphik_ausgabe.pack()
  lb_prozeß_ausgabe_gitter_graphik_datei_ausgabe = tkinter.Label(main, text = ausgabe.rückgabeliste[9])
  lb_prozeß_ausgabe_gitter_graphik_datei_ausgabe.pack()


#*************************************************************
# Button zur Beendigung des Programms
#*************************************************************   
  bende = tkinter.Button(main, text = "Ende",command = ende)
  bende.pack()
#*************************************************************
# Endlosschleife
#*************************************************************
  main.mainloop()
#*************************************************************
#Programmende
#*************************************************************
