#*************************************************************
# Progamm:			fluisa_gitter_1d
# Sinn des Programms: 		Gittergenerator
# Sinn der Einheit  :		Berechnung des Gitters
# Name dieser Datei:		gitter.py
# Versionsnummer:		1
# Wird aufgerufen von:		fluisa_gitter_1d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	3
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			04.12.2017
# Letzte Änderung: 		24.01.2024
#*************************************************************

from steuer import Steuer


import numpy as np

class Gitter:
  #Konstruktormethode
  def __init__(self):		
    print("Gitterobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Gitterobjekt entfernt") 

  def gitter_rechner(self,gitter_typ,m,x_west, x_ost, A_init):
    self.rückgabeliste = list(range(3))
    self.rückgabeliste[0] = True 				# Erstellen des Gitters korrekt            True/False
    self.rückgabeliste[1] = "Gitter wurde korrekt errechnet."	# Fehlermeldung für Einlesen aus Gitterdatei  Text
    self.rückgabeliste[2] = "FVM-Gitter"                     	# Gitter Typ Text

    try:
      print("Gittergenerator")
      print("Gitterart=",gitter_typ)
      print("m=",m)
      self.x = np.zeros(m)
      self.delta_x = np.zeros(m-1)
      if gitter_typ == 'v' :
        m-=1
      print("Gittergrenzen:",x_west, x_ost);
      print("Anzahl der Gitterpunkte in Gitter",m)
      print("Gittergrenzen: ",x_west, x_ost)
      print("Grenzflächeninhalt",A_init)
      
      if self.fdm_gitter( m, x_west, x_ost):
        pass
      else:
        self.rückgabeliste[0] = False
        
      if gitter_typ == "d":
        self.rückgabeliste[2] = "FDM-Gitter wurde berechnet."
             
      elif gitter_typ == "v" :  
        self.rückgabeliste[2] = "FVM-Gitter wurde berechnet."    
        if self.fvm_gitter( m, x_west, x_ost, A_init):
          pass
        else:
          fself.rückgabeliste[0] = False
      else:
        print("Fehler im System")    
        self.rückgabeliste[0] = False
       
    except:
      self.rückgabeliste[0] = False
    print("Fehlermelder:",self.rückgabeliste[0])
    return self.rückgabeliste[0]


  def fdm_gitter(self, m, x_west, x_ost):
    try:      
      print("Anzahl Gitterpunkte im prim-Gitter = " , m)
      print("Grenzen:", x_west, x_ost)
      self.delta_x_init = (x_ost-x_west)/float(m-1)
      for i in range(m):
        self.x[i] = x_west + float(i)*self.delta_x_init
        print("fdm-Gitter i=",i,"x=", self.x[i]) 
      for i in range(m-1):	
        self.delta_x[i] = self.x[i+1] - self.x[i]
      print("FDM-Gitter wurde berechnet")      
      return True
    except:
      print("Fehler bei der Berchnung des FDM-Gitters")
      return False  
         
    
    
  def fvm_gitter(self, m, x_west, x_ost, A_init):
    # m wurde dekrementiert am Anfang von gitter_rechner(), da fvm-Gitter
    # die Feldindizes in der zeros-Funktion wurden daher inkrementiert
    try:
      self.x_gf = np.zeros(m)
      self.A_gf = np.zeros(m)   
      self.Delta_x = np.zeros(m-1)
      self.V = np.zeros(m-1)
      self.n_vektor_west = np.zeros(m-1)
      self.n_vektor_ost = np.zeros(m-1)
      
      print("FVM-Gitter")
      
      for i in range(m):
        self.x_gf[i] = self.x[i]
        print("i=",i,"x_gf=", self.x_gf[i])      

      print("Grenzflächenposition:",self.x_gf)       

      for i in range(m):
        self.A_gf[i] = A_init
        print("Grenzflächeninhalt: A_gf[",i,"]",self.A_gf[i])   

      for i in range(m-1):
        self.Delta_x[i] = self.x_gf[i+1] - self.x_gf[i]  
     
      for i in range(m-1):
        self.V[i] = self.A_gf[i]*self.Delta_x[i]
        self.n_vektor_west[i] = -1-0
        self.n_vektor_ost[i] = 1.0       
        print("V[",i,"]", self.V[i], "n_vektor_west[",i,"]", self.n_vektor_west[i], "n_vektor_ost[",i,"]", self.n_vektor_ost[i])            
      
      self.x[0] = x_west
      self.x[m] = x_ost
      
      for i in range(1,m):
        self.x[i] = (self.x_gf[i]+self.x_gf[i-1])/2.0
        
      for i in range(0,m+1):  
        print(i, self.x[i])
        #print("nach verschieben:",self.x[i])        
      
      for i in range(m):
        self.delta_x[i] = self.x[i+1] - self.x[i]
        print("delta_x[",i,"]=",self.delta_x[i]) 
             

      print("FVM-Gitter wurde berechnet")
        # Die Ausgabefunktionen bekommen steuer.m, welches unverändert ist 
      m+=1 
      return True  
    except:
      print("Fehler bei der Berechnung des FVM-Gitters")
      return False  
                   
  

  
